declare('extraCommands', {})
extraCommands.version = '0.21'

--## Choco ##--

local faction_colors = {
	['itani']={['index']=1, ['color']='6080ff'},
	['serco']={['index']=2, ['color']='ff2020'},
	['uit']={['index']=3, ['color']='c0c000'},
	['tpg']={['index']=4},
	['biocom']={['index']=5},
	['valent']={['index']=6},
	['orion']={['index']=7},
	['axia']={['index']=8},
	['corvus']={['index']=9},
	['tunguska']={['index']=10},
	['aeolus']={['index']=11},
	['ineubis']={['index']=12},
	['xangxi']={['index']=13},
	['xx']={['index']=13},
}

function extraCommands:HudMsg(args)
	if args then HUD:PrintSecondaryMsg(table.concat(args, " ")) end
end

function extraCommands:DebugMsg(args)
	if args then
		local msg = table.concat(args, " ") or ''
		print('\127808080'..msg)
		console_print(msg)
	end
end

function extraCommands:getRadar(args)
	local nodeid, objid = radar.GetRadarSelectionID()
	console_print(spickle({nodeid, objid}))
end


function extraCommands:togglechat(args)
	if HUD['visibility']['chat'] == "YES" then HUD['visibility']['chat'] = "NO"
	else HUD['visibility']['chat'] = "YES" end
	
	HUD:UpdateHUDvisibility()
end

function extraCommands:charInfo(args)
	for i=1,6 do
		local name, faction, money, kills, deaths, loc, home = GetCharacterInfo(i)
		if name == GetPlayerName() then
			loc = GetCurrentSectorid()
			home = GetHomeStation()
		end
		if name and faction_colors[faction:lower()] then
			local colorid = faction_colors[faction:lower()]['color'] or 'ffffff'
			print('\127'..colorid..name..'\tloc:'..ShortLocationStr(loc)..'\thome: '..ShortLocationStr(home)..'\tmoney: '..money..'c')
		end
	end
end

function extraCommands:getfaction(args)
	if args then
		if faction_colors[args[1]:lower()] then
			print(GetPlayerFactionStanding( faction_colors[args[1]:lower()]['index'] ))
			console_print(args[1].." "..GetPlayerFactionStanding( faction_colors[args[1]:lower()]['index'] ))
		else print('Invalid faction name: '..args[1]:lower()) end
	else print('You must specify a faction. 0=KOS, 65535=POS') end
end

function extraCommands.help()
	print('\127ffffffExtraCommands v'..extraCommands.version..' Available commands are:'..
	'\n\t/hud_msg \127ffff00TEXT\127o - briefly displays specified message on HUD'..
	'\n\t/chattoggle - toggles visibility of chat'..
	'\n\t/chars - gives location and money of all chars for this account'..
	'\n\t/getfaction \127ffff00FACTION\127o- gives exact standing for specified \127ffff00FACTION\127o')
end

RegisterUserCommand("extracommands", extraCommands.help)
RegisterUserCommand("hud_msg", extraCommands.HudMsg)
RegisterUserCommand("debug_msg", extraCommands.DebugMsg)
RegisterUserCommand("chattoggle", extraCommands.togglechat)
RegisterUserCommand("chars", extraCommands.charInfo)
RegisterUserCommand("getfaction", extraCommands.getfaction)
RegisterUserCommand("getradar", extraCommands.getRadar)